package com.javaxing.springsentineldemo.controller;

import com.alibaba.csp.sentinel.Entry;
import com.alibaba.csp.sentinel.SphU;
import com.alibaba.csp.sentinel.annotation.SentinelResource;
import com.alibaba.csp.sentinel.slots.block.BlockException;
import com.alibaba.csp.sentinel.slots.block.RuleConstant;
import com.alibaba.csp.sentinel.slots.block.flow.FlowRule;
import com.alibaba.csp.sentinel.slots.block.flow.FlowRuleManager;
import com.javaxing.springsentineldemo.config.ExceptionConfiguration;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.PostConstruct;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;

@RestController
public class TestSpringBootSentinelController {

    //    @SentinelResource(value = "springBootSentinel",
//            blockHandler = "handleException",
//            fallback = "fallbackException")

    AtomicInteger atomicInteger = new AtomicInteger();


    @GetMapping("/springBootSentinelSuccess")
    public String springBootSentinelSuccess() {
        return "正常的业务逻辑执行...";
    }

    @GetMapping("/springBootSentinelException")
    public String springBootSentinelException() {
//        atomicInteger.getAndIncrement();
//        if (atomicInteger.get() % 2 == 0) {
//            // 模拟代码异常
//            int a = 1 / 0;
//        }
        return "正常的业务逻辑执行...";
    }

    @SentinelResource(value = "springBootSentinelSuccessHotData",
            blockHandler = "handleException",
            fallback = "fallbackException")
    @GetMapping("/springBootSentinelSuccessHotData")
    public String springBootSentinelSuccessHotData(@RequestParam("orderId") Integer orderId) throws InterruptedException {
        // 模拟代码异常
        return "正常的业务逻辑执行...";
    }

    public String handleException(BlockException ex) {
        return "被流控了";
    }

    public String fallbackException(Throwable t) {
        return "被异常降级了";
    }


//    @SentinelResource(value = "springBootSentinel",
//            blockHandler = "handleException",blockHandlerClass = ExceptionConfiguration.class,
//            fallback = "fallback",fallbackClass = ExceptionConfiguration.class)
//    @GetMapping("/springBootSentinelExceptionConfiguration")
//    public String springBootSentinelExceptionConfiguration(){
//        // 模拟代码异常
//        int a = 1/0;
//        return "正常的业务逻辑执行...";
//    }
//
//    @SentinelResource(value = "springBootSentinel",
//            blockHandler = "handleException",blockHandlerClass = ExceptionConfiguration.class,
//            fallback = "fallbackException",fallbackClass = ExceptionConfiguration.class)
//    @GetMapping("/springBootSentinelSuccessConfiguration")
//    public String springBootSentinelSuccessConfiguration(){
//        // 模拟代码异常
//        return "正常的业务逻辑执行...";
//    }

    @GetMapping("/writeSentinelTest")
    public String writeSentinelTest() {
        return "写入成功...";
    }


    @GetMapping("/test1")
    public String test1() {
        queryOrderInfo();
        return "写入成功...";
    }


    @GetMapping("/test2")
    public String test2() {
        queryOrderInfo();
        return "写入成功...";
    }

    @SentinelResource(value = "queryOrderInfo", blockHandler = "handleException")
    public void queryOrderInfo() {
        System.out.println("进入了订单查询详情");
    }

    public String handleException(Integer id, BlockException ex) {
        return "被限流啦";
    }


}
